import gc
import sys

from PyQt4 import QtCore, QtGui


class MyThread(QtCore.QThread):

    def __init__(self, parent):
        QtCore.QThread.__init__(self, parent)

    def run(self):
        for i in xrange(1000):
            print i
        print "I did my part!"

    def __del__(self):
        print "But the thread persisted until the widget went out of scope!"



class MyWidget(QtGui.QWidget):

    def __init__(self):
        QtGui.QWidget.__init__(self)
        self.thread = MyThread(self)
        self.thread.start()

        self.connect(
            self.thread,
            QtCore.SIGNAL("finished()"),
            self.processComplete
        )

    def processComplete(self):
        print 'got finished signal, attempting to delete thread...'
        self.thread = None
        gc.collect()


if __name__ == "__main__":
    myApp = QtGui.QApplication(sys.argv)
    w = MyWidget()
    w.show()
    sys.exit(myApp.exec_())